#ifndef ENTITY_H
#  define ENTITY_H

#  include <stdbool.h>
#  include "cj.h"

   Entity       makeEntity(void);
   EntityArray  makeEntityArray(void);
   EntityObject makeEntityObject(void);

   void addToEntityArray(Entity *entityPtr, EntityArray *array);
   void freeEntityArray(EntityArray *array);

   void addToEntityObject(EntityObjectEntry *entryPtr, EntityObject *objectPtr);
   void freeEntityObject(EntityObject *object);
   EntityObjectEntry makeEntityObjectEntry(void);

   void printEntity(Entity *entityPtr);
   void freeEntity(Entity *ptr);
   bool getEntity(EntityArray *array, Entity *entityPtr, CJString *errMsg);

   bool tokensToEntities(TokenList *tokenList, EntityArray *array, CJString *errMsg);

#endif
